#pragma once

#include "_includes.h"

//====================================================
//       :
// https://www.interestprograms.ru
//     
//====================================================

void BlockingBsendRecv(int rank, int count_processes)
{
	//      MPI_Datatype.
	const int count_mpi_int = 2;

	//   .
	int repeat = 3;

	if (rank == 0)
	{
		if (count_processes > 1)
		{
			//        .
			int total_sum = 0;

			//     .
			for (int i = 1; i < count_processes; i++)
			{
				int sum = 0;
				//   . 
				//       4.
				//if(i < count_processes - 1)
				for (int j = 0; j < repeat; j++)
				{
					//     .
					int receive_number[count_mpi_int] = { 0 };

					//   =0       .
					MPI_Recv(&receive_number, count_mpi_int, MPI_INT, i, MPI_ANY_TAG, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

					//   .
					for (int m = 0; m < count_mpi_int; m++)
					{
						//      .
						std::cout << "#" << j << ": rank " << i << " receive_number[" << m << "]: " << receive_number[m] << "\n";

						//    -
						sum += receive_number[m];
					}
				}
				//    -.
				std::cout << "--- rank " << i << " sum=" << sum << " ---\n";

				//     .
				total_sum += sum;
			}

			//   .
			std::cout << "Total sum=" << total_sum << "\n";
		}
	}
	else
	{
		//      
		//   MPI.
		int mpi_int_size = 0;
		MPI_Type_size(MPI_INT, &mpi_int_size);
		std::cout << "message size - " << mpi_int_size * count_mpi_int << "\n";

		//       :
			//      .
		int buffer_size = mpi_int_size * count_mpi_int + MPI_BSEND_OVERHEAD;

		for (int i = 0; i < repeat; i++)
		{
			//   .
			int random_numbers[count_mpi_int] = { 0 };

			//     .
			for (int j = 0; j < count_mpi_int; j++)
			{
				random_numbers[j] = std::rand();
			}

			//      
			//    .
			unsigned char* buffer = new unsigned char[buffer_size];
			memset(buffer, 0, buffer_size);
			std::cout << "buffer size - " << buffer_size << "\n";

			//      .
			MPI_Buffer_attach(
				buffer,
				buffer_size
			);

			//   .
			std::cout << "addr_buffer_attach: " << (void*)buffer << "\n";

			//    =0  .
			MPI_Bsend(&random_numbers, count_mpi_int, MPI_INT, 0, 0, MPI_COMM_WORLD);

			//   .
			//     
			//   .
			//      .
			int buffer_detach_size = 0;
			unsigned char* addr_buffer_detach = nullptr;
			MPI_Buffer_detach(&addr_buffer_detach, &buffer_detach_size);
			delete[] buffer;

			std::cout << "buffer_detach_size = " << buffer_detach_size << "\n";
			std::cout << "addr_buffer_detach: " << (void*) addr_buffer_detach << "\n";
		}
	}
}