
#include "_includes.h"

//====================================================
//       :
// https://www.interestprograms.ru
//     
//====================================================

struct SDATA
{
	int num1 = -1;
	float num2 = -1;
	double num3 = -1;
	bool boolean1 = true;
	char symbols[50] = "Hello from process ";
};


//    .
void BlockingSendRecv(int rank, int count_processes)
{
	//       float
	std::cout.precision(10);

	//       .
	//   MPI    MPI_BYTE.
	int buffer_size =  sizeof(SDATA);

	if (rank == 0)
	{
		if (count_processes > 1)
		{
			//     .
			for (int i = 1; i < count_processes; i++)
			{
				//   .
				SDATA recv_data;

				//      
				//     4.
				//if(i < count_processes - 1)
				//    0        .
				MPI_Recv(&recv_data, buffer_size, MPI_BYTE, i, MPI_ANY_TAG, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
				
				//      .
				std::cout << "--- Receive from rank " << i << " ---\n";
				std::cout << "int: " << recv_data.num1 << "\n";
				std::cout << "float: " << recv_data.num2 << "F\n";
				std::cout << "double: " << recv_data.num3 << "\n";
				std::cout << "bool: " << recv_data.boolean1 << "\n";
				std::cout << "chars: " << recv_data.symbols << "\n";
			}
		}
	}
	else
	{
		//     .
		SDATA send_data;
		send_data.num1 = std::rand();
		send_data.num2 = std::rand() / 1.37f;
		send_data.num3 = std::rand() / 1.37;
		send_data.boolean1 = std::rand() % 2 == 0;

		//     .
		char num_rank[5] = "";
		_itoa_s(rank, num_rank, sizeof(num_rank), 10);

		//      .
		strcat_s(send_data.symbols, 50, num_rank);

		//     0   .
		MPI_Send(&send_data, buffer_size, MPI_BYTE, 0, 0, MPI_COMM_WORLD);

		//   
		std::cout << "--- Sent data " << " ---\n";
		std::cout << "int: " << send_data.num1 << "\n";
		std::cout << "float: " << send_data.num2 << "\n";
		std::cout << "double: " << send_data.num3 << "\n";
		std::cout << "bool: " << send_data.boolean1 << "\n";
		std::cout << "chars: " << send_data.symbols << "\n";
	}
}